#include "phylip.h"
#define namelength      10   /* maximum number of characters in species name */

#define ibmpc0          false
#define ansi0           true
#define vt520           false

#define point           "."

typedef double *phenotype;
typedef Char naym[namelength];
typedef struct node {
  struct node *next, *back;
  boolean tip;
  long number;
  phenotype view;
  naym nayme;
  double v;
} node;

typedef struct tree {
  node **nodep;
  node *start;
} tree;

void openfile(FILE **fp,char *filename,char *mode,
	char *application,char *perm);
void uppercase(Char *ch);
void getnums();
void getoptions();
void getdata();
void doinit();
void setuptree(tree *a);
void hookup(node *p,node * q);
void setuptip(long m, tree *t);
void getch(Char *c);
void findch(Char c,long * lparens,long *rparens);
void findeither(long *lparens,long *rparens,boolean *rtparen);
void processlength(node *p);
void addelement(node *p,long * nextnode,long *lparens,
	long *rparens,boolean *names);
void treeread();
void initcontrasts();
void contbetween(node *p,node * q);
void nuview(node *p);
void setstart(node *p);
void setview(node *p);
void makecontrasts(node *p);
void writecontrasts();
void regressions();
void maketree();
int eof(FILE *f);
int eoln(FILE *f);
void memerror();
MALLOCRETURN *mymalloc(long x);
